<?php
    /* -----backup/backuplib.php copy----- */
    
    //check whether there is a file to copy
    function course_files_check_copy($course,$tocourse,$backup_unique_code,$resourcetopass) {
    
        global $CFG,$SESSION;
    
        $rootdir = $CFG->dataroot."/$course";
        
        //Check if directory exists
        if (is_dir($rootdir)) {
            //Get files and directories without descend
            $coursedirs = course_files_get_list($course,$resourcetopass);
            
        // same name file rename        
        $changefiles = course_files_name_check($coursedirs, $tocourse);
        // coursefile list
        if (isset($coursedirs)) {
                $SESSION->coursefiles = $coursedirs;
        }
        // same name list
        if (isset($changefiles)) {
            $SESSION->changefiles = $changefiles;
        }
        //$coursedirs = get_directory_list($rootdir,$CFG->moddata,false,true,true);
            $backupdata_dir = "backupdata";
        
        //file and directory which there is in a resource
        $regex = "/file\.php\/".$course."\/([[:alnum:]\+\$\?\.%,!#~\*\/:@&=_\-]+)/i"; 
        $httpregex = "/^(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/";
        $file ="file.php";

       foreach ($coursedirs as $dir) {
                //Check it isn't backupdata_dir
                if (strpos($dir,$backupdata_dir)!==0) {
                    //Insert them into backup_files
                    $status = execute_sql("INSERT INTO {$CFG->prefix}backup_files
                                                  (backup_code, file_type, path)
                                           VALUES
                                              ('$backup_unique_code','course','".addslashes($dir)."')",false);
                }
            //Do some output
            backup_flush(30);
            }
        }
        //Now execute the select
        $ids = get_records_sql("SELECT DISTINCT b.path, b.old_id
                                FROM {$CFG->prefix}backup_files b
                                WHERE backup_code = '$backup_unique_code' AND
                                      file_type = 'course'");
        //Gets the user data
        $info[0][0] = get_string("files");
        if ($ids) {
            $info[0][1] = count($ids);
        } else {
            $info[0][1] = 0;
        }

        return $info; 
   }
    // file in resource and label list
    function course_files_get_list($course,$resourcetopass) {
        
        global $CFG;
        
        $rootdir = $CFG->dataroot."/$course";
        //Check if directory exists
        if (is_dir($rootdir)) {
        
            //dir and file
            $regex = "/file\.php\/".$course."\/([[:alnum:]\+\$\?\.%,!#~\*\/:@&=_\-]+)/i"; 
            $httpregex = "/^(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/";
            $file ="file.php";
            $coursefiles = array();     //course_file
            $coursedir = array();       //course_directory
        
        foreach ($resourcetopass as $instance=>$var) {
            
            if ($var->mod == "label") {
            $labelinstance = get_record("label","id",$var->id);
            
            if (strpos($labelinstance->content,$file)) {
                        preg_match_all($regex,$labelinstance->content,$labelfiles);
                    for ($i=0; $i< count($labelfiles[1]); $i++) {
                        $coursefiles[] = $labelfiles[1][$i];
                }
            }
            } elseif ($var->mod =="resource") {
                $resourceinstance = get_record("resource","id",$var->id);
                //case of a tree
                $resourcelist = array();
                if ($resourceinstance->type=="tree") {
                    $treelist = tree_id_list($resourceinstance->id);
                    $resourcelist = $treelist;
                }
                
                $resourcelist[] = $resourceinstance;
                
                foreach ($resourcelist as $num=>$rsid){
                    //directory reference
                    if ($rsid->type=="directory" && !empty($rsid->reference)) {
                        $coursedir[] = $rsid->reference;
                     }
                    //file reference
                    if ($rsid->type=="file" && !empty($rsid->reference)) {
                        
                        if (!preg_match($httpregex, $rsid->reference)) {
                            $coursefiles[] = $rsid->reference;
                        }
                    }
                        //resource alltext
                    if (strpos($rsid->alltext,$file)) {
                        
                        preg_match_all($regex,$rsid->alltext,$alltextfiles);
                        
                        for ($i=0; $i< count($alltextfiles[1]); $i++) {
                            $coursefiles[] = $alltextfiles[1][$i];
                        }
                    }
                    //resource summary
                    if (strpos($rsid->summary,$file)) {
                        
                        preg_match_all($regex,$rsid->summary,$summaryfiles);
                            
                           for ($i=0; $i< count($summaryfiles[1]); $i++) {
                            $coursefiles[]=$summaryfiles[1][$i];
                        }
                    }
                }
            }
        }
            
            if (!empty($coursefiles)) {
                if (sort($coursefiles = array_unique($coursefiles))) {
                    if ($count = count($coursedir) > 0) {
                        for ($i=0; $i < $count;$i++) {
                            for ($s=0; $s < count($coursefiles);$s++) {
                                if (strstr($coursefiles[$s],$coursedir[$i])) {
                                    $coursefiles[$s] = $coursedir[$i];
                                }
                            }
                        }
                    }
                }
            } else {
                $coursefiles = $coursedir;
            }
        }
        sort($coursefiles = array_unique($coursefiles));
        
        return $coursefiles;
        
    }
    
    // backup/backup/lib.php :function backup_copy_course_files ($preferences) {
    //This function copies all the course files under the course directory (except the moddata
    //directory to the "course_files" directory under temp/backup
    function backup_copy_course_files_2 ($preferences) {
        
        global $CFG,$SESSION;
        
        $status = true;
        
        //First we check to "course_files" exists and create it as necessary
        //in temp/backup/$backup_code  dir
        $status = check_and_create_course_files_dir($preferences->backup_unique_code);
        
        //Now iterate over files and directories except $CFG->moddata and backupdata to be
        //copied to backup
        
        $rootdir = $CFG->dataroot."/".$preferences->backup_course;
        
        $name_moddata = $CFG->moddata;
        $name_backupdata = "backupdata";
        
        // Check if directory exists
        if (is_dir($rootdir)) {
            $copycourse = $SESSION->cal_course_referer;
            $cflist = $SESSION->changefiles;
            $coursefilelist = array();
            foreach ($SESSION->coursefiles as $file) {
                $coursefilelist[] = explode("/",$file);    
            }
            
            $dirpath = $CFG->dataroot."/temp/backup/".$preferences->backup_unique_code."/course_files/";
            foreach($coursefilelist as $var=>$path) {
            
                $pathlist = '';
                
                for ($i=0;$i<count($path);$i++) {
                    if (!file_exists($dirpath.$pathlist.$path[$i])) {
                          if(is_file($rootdir."/".$pathlist.$path[$i])) {               
                            $status = backup_copy_file($rootdir."/".$pathlist.$path[$i], 
                            $dirpath."/".$pathlist.$path[$i]);
                          } else {
                            $status = mkdir($dirpath.$pathlist.$path[$i], $CFG->directorypermissions);
                        }
                    }
                    if(!empty($pathlist)) {
                        $pathlist = $pathlist.$path[$i]."/";
                        
                    } else {
                        $pathlist = $path[$i]."/";
                    }
                }
            }
        //rename
            if (!empty($cflist)) {
                foreach ($cflist as $oldname=>$newname) {
                    if (file_exists($dirpath.$oldname)) {
                        rename($dirpath.$oldname,$dirpath.$newname);
                    }
                }
            }
        }
        
        return $status;
    }
    
    // course_file name check!!
    // same name changes a name
    //
    function course_files_name_check($list,$copycourse) {
        
        global $CFG,$SESSION;
        
        $rootdir = $CFG->dataroot.'/'.$copycourse;
        $changefiles = array();
        
        for ($i=0;$i<count($list);$i++) {
            $listpath = array();
            if (strstr($list[$i],'/')) {
                $listpath = explode('/',$list[$i]);
                $list[$i] = $listpath;
            } else {
                $listpath[0] = $list[$i];
                $list[$i] = $listpath;
            }
        }
        
        $copycoursedirs = list_directories_and_files($rootdir);
        
        if(!empty($copycoursedirs)) {
            $cpcsdirs = array_values($copycoursedirs);
            $cnt = count($cpcsdirs);
            $dir_ary = array();
            $fil_ary = array();
            for ($i = 0; $i < $cnt; $i++) {
                if (is_dir($rootdir . '/' . $cpcsdirs[$i])) {
                    array_push($dir_ary, $cpcsdirs[$i]);
                    sort($dir_ary);
                   
                } else {
                    array_push($fil_ary, $cpcsdirs[$i]);
                    sort($fil_ary);
                   
                }
            }
            
            $SESSION->changefile_isdir = $dir_ary;
            $SESSION->changefile_isfil = $fil_ary;
            $dir_rep_ary = array();
            foreach ($dir_ary as $num => $dir_name) {
                $ad_num = 1;
                foreach ($list as $key => $path) {
                    if ($path[0] == $dir_name) {
                        $dir_key = $path[0];
                        $path[0] == $dir_name . '_' . $ad_num;
                        $target_dir = $path[0];    
                    }
                }
                if ($dir_name == @$target_dir) {
                    $dir_rep_name = $target_dir . '_' . $ad_num;
                    $target_dir = $dir_rep_name;
                    $changefiles[$dir_key] = $dir_rep_name;
                }
            }
            unset($target_dir);
            unset($dir_rep_name);
            
            $fil_rep_ary = array();
            foreach ($fil_ary as $num => $fil_name) { 
                $ad_num = 1;          
                foreach ($list as $key => $path) {
                    if ($path[0] == $fil_name) {
                        $file_key = $path[0];
                        $path[0] = str_replace('.', '_' . $ad_num . '.', $fil_name);
                        $target_file = $path[0];
                        $changefiles[$file_key] = $target_file;
                    }
                }
                if ($fil_name == $target_file) {
                    $fil_rep_name = str_replace('.', '_' . $ad_num . '.', $target_file);
                    $target_file = $fil_rep_name;
                    $changefiles[$file_key] = $fil_rep_name;
                }  
            }
            unset($target_file);
            unset($fil_rep_name);
        }
            
        if ($status = isset($changefiles)) {
            return $changefiles;
            
        } else {
            return $status;
            
        }
    }

    // collect all resourceid of tree 
    function tree_id_list($treersid) {
        
        $treeinstance = get_record("resource","id",$treersid);
        
        if (!empty($treeinstance->type) && ($treeinstance->type == "tree")) {
            
            $allresource = array(); //all resourceinstance
            $alltextary = explode("<!-- id -->", htmlspecialchars_decode($treeinstance->alltext, ENT_QUOTES));
            $cmidary = array();
            @$cmidary[0] = explode(":",$alltextary[1]);
            
            foreach($cmidary[0] as $key=>$var) {
                if(empty($var)) {
                        unset($cmidary[0][$key]);
                }
            }
            //sort
            array_values($cmidary[0]);
            $i = 0;
            while (@$cmidary[$i]) {
                foreach ($cmidary[$i] as $key=>$val) {
                $cm = get_record("course_modules","id",$val);
                    $rs = get_record("resource","id",$cm->instance);
                    $allresource[] = $rs;
                                $rs->alltext = htmlspecialchars_decode($rs->alltext, ENT_QUOTES);
                    if(strstr($rs->alltext,"<!-- id -->")) {
                           $alltextary = explode("<!-- id -->", $rs->alltext);
                        if (strstr($alltextary[1], ':')) {
                            $textnum =  explode(":",$alltextary[1]);
                            foreach($textnum as $num=>$ans) {
                                if(empty($ans)) {
                                    unset($textnum[$num]);
                                }
                                $textnum[$num] = trim($textnum[$num]);
                            }
                            //sort
                            array_values($textnum);
                            if (!empty($textnum)) {
                                array_push($cmidary, $textnum);
                            }
                        }
                    }
                }
                $i++;
            }
            return $allresource;
            
        } else {
            return false;
        }
    }

    /* -----backup/restorelib.php copy----- */
    
    //This function creates all the course_sections and course_modules from xml
    //when restoring in a new course or simply checks sections and create records
    //in backup_ids when restoring in a existing course
    function restore_create_sections_2(&$restore, $xml_file) {
        
        global $CFG,$db;
        
        $status = true;
        //Check it exists
        if (!file_exists($xml_file)) {
            $status = false;
        }
        //Get info from xml
        if ($status) {
            $info = restore_read_xml_sections($xml_file);
        }
        //Put the info in the DB, recoding ids and saving the in backup tables
        
        $sequence = "";
        
        if ($info) {
            //For each, section, save it to db
            foreach ($info->sections as $key => $sect) {
                $sequence = "";
                $section->course = $restore->course_id;
                $section->section = $sect->number;
                $section->summary = restore_decode_absolute_links(addslashes($sect->summary));
                $section->visible = $sect->visible;
                $section->sequence = "";
                //Now calculate the section's newid
                $newid = 0;
                if ($restore->restoreto == 2) {
                    //Save it to db (only if restoring to new course)
                    $newid = insert_record("course_sections",$section);
                } else {
                    //maintain a section or not maintain a section
                    if ($restore->course_sectionkeep) {
                        //Get section id when restoring in existing course
                        $rec = get_record("course_sections","course",$restore->course_id,
                                                            "section",$section->section);
                        //If that section doesn't exist, get section 0 (every mod will be
                        //asigned there
                        //To the section that I operated if there was not the same section
                        if(!$rec) {
                            $rec = get_record("course_sections","course",$restore->course_id,
                                                                "section",$restore->course_sectionin);
                        }
                        //New check. If section 0 doesn't exist, insert it here !!
                        //Teorically this never should happen but, in practice, some users
                        //have reported this issue.
                        if(!$rec) {
                            $zero_sec->course = $restore->course_id;
                            $zero_sec->section = 0;
                            $zero_sec->summary = "";
                            $zero_sec->sequence = "";
                            $newid = insert_record("course_sections",$zero_sec);
                            $rec->id = $newid;
                            $rec->sequence = "";
                        }
                        $cse = get_record("course", "id", $restore->course_id);
                        if ($rec->section > $cse->numsections) {
                            $rec = get_record("course_sections","course",$restore->course_id,
                                                            "section",$restore->course_sectionin);
                            //If that section doesn't exist, get section 0 (every mod will be
                            //asigned there
                            if(!$rec) {
                                $rec = get_record("course_sections","course",$restore->course_id,
                                                                    "section","0");
                            }
                            //New check. If section 0 doesn't exist, insert it here !!
                            //Teorically this never should happen but, in practice, some users
                            //have reported this issue.
                            if(!$rec) {
                                $zero_sec->course = $restore->course_id;
                                $zero_sec->section = 0;
                                $zero_sec->summary = "";
                                $zero_sec->sequence = "";
                                $newid = insert_record("course_sections",$zero_sec);
                                $rec->id = $newid;
                                $rec->sequence = "";
                            }
			}
                        $newid = $rec->id;
                        $sequence = $rec->sequence;
                        
                    } else {
                        //The section information that I operated
                        $rec = get_record("course_sections","course",$restore->course_id,
                                                            "section",$restore->course_sectionin);
                        //If that section doesn't exist, get section 0 (every mod will be
                        //asigned there
                        if(!$rec) {
                            $rec = get_record("course_sections","course",$restore->course_id,
                                                                "section","0");
                        }
                        //New check. If section 0 doesn't exist, insert it here !!
                        //Teorically this never should happen but, in practice, some users
                        //have reported this issue.
                        if(!$rec) {
                            $zero_sec->course = $restore->course_id;
                            $zero_sec->section = 0;
                            $zero_sec->summary = "";
                            $zero_sec->sequence = "";
                            $newid = insert_record("course_sections",$zero_sec);
                            $rec->id = $newid;
                            $rec->sequence = "";
                        }
                        $newid = $rec->id;
                        $sequence = $rec->sequence;
                    }
                }
                if ($newid) {
                    //save old and new section id
                    backup_putid ($restore->backup_unique_code,"course_sections",$key,$newid);
                } else {
                    $status = false;
                    
                }
                //If all is OK, go with associated mods
                if ($status) {
                    //If we have mods in the section
                    if (!empty($sect->mods)) {
                        //For each mod inside section
                        foreach ($sect->mods as $keym => $mod) {
                            // Yu: This part is called repeatedly for every instance, 
                            // so it is necessary to set the granular flag and check isset() 
                            // when the first instance of this type of mod is processed.
                            if (!isset($restore->mods[$mod->type]->granular) && isset($restore->mods[$mod->type]->instances) && is_array($restore->mods[$mod->type]->instances)) {
                                // This defines whether we want to restore specific
                                // instances of the modules (granular restore), or
                                // whether we don't care and just want to restore
                                // all module instances (non-granular).
                                $restore->mods[$mod->type]->granular = true;
                            } else {
                                $restore->mods[$mod->type]->granular = false;
                            }
                            //Check if we've to restore this module (and instance) 
                            if (!empty($restore->mods[$mod->type]->restore) && $restore->mods[$mod->type]->restore == 1) {                      
                                if ((array_key_exists($mod->instance,$restore->mods[$mod->type]->instances) 
                                     && !empty($restore->mods[$mod->type]->instances[$mod->instance]->restore)
                                     && $restore->mods[$mod->type]->instances[$mod->instance]->restore == 1)) {

                                    //Get the module id from modules
                                    $module = get_record("modules","name",$mod->type);
                                    if ($module) {
                                        $course_module->course = $restore->course_id;
                                        $course_module->module = $module->id;
                                        $course_module->section = $newid;
                                        $course_module->added = $mod->added;
                                        $course_module->score = $mod->score;
                                        $course_module->indent = $mod->indent;
                                        $course_module->visible = $mod->visible;
                                        if (isset($mod->groupmode)) {
                                            $course_module->groupmode = $mod->groupmode;
                                        }
                                        $course_module->instance = 0;
                                        //NOTE: The instance (new) is calculated and updated in db in the
                                        //      final step of the restore. We don't know it yet.
                                        //print_object($course_module);                    //Debug
                                        //Save it to db

                                        $newidmod = insert_record("course_modules",$course_module); 
                                        if ($newidmod) {
                                            //save old and new module id
                                            //In the info field, we save the original instance of the module
                                            //to use it later
                                            backup_putid ($restore->backup_unique_code,"course_modules",
                                                          $keym,$newidmod,$mod->instance);
                                            
                                            $restore->mods[$mod->type]->instances[$mod->instance]->restored_as_course_module = $newidmod;
                                        } else {
                                            $status = false;
                                            
                                        }
                                        //Now, calculate the sequence field
                                        if ($status) {
                                            if ($sequence) {
                                                $sequence .= ",".$newidmod;
                                            } else {
                                                $sequence = $newidmod;
                                            }
                                        }
                                    } else {
                                        $status = false;
                                        
                                    }
                                }
                            }
                        }
                    }
                }
                //If all is OK, update sequence field in course_sections
                if ($status) {
                    if (isset($sequence)) {
                        $update_rec->id = $newid;
                        $update_rec->sequence = $sequence;
                        $status = update_record("course_sections",$update_rec);
                    }
                }
            }
        } else {
            $status = false;

        }
        return $status;
        
    }

    function restore_check_instances_2($restore) {
        
        global $CFG, $SESSION;
        
        $status = true;
        
        //We are going to iterate over each course_module saved in backup_ids
        $course_modules = get_records_sql("SELECT old_id,new_id
                                           FROM {$CFG->prefix}backup_ids
                                           WHERE backup_code = '$restore->backup_unique_code' AND
                                                 table_name = 'course_modules'");
        
        if ($course_modules) {
            foreach($course_modules as $cm) {
                //Get full record, using backup_getids
                $cm_module = backup_getid($restore->backup_unique_code,"course_modules",$cm->old_id);
                //Now we are going to the REAL course_modules to get its type (field module)
                $module = get_record("course_modules","id",$cm_module->new_id);
                if ($module) {
                    //We know the module type id. Get the name from modules
                    $type = get_record("modules","id",$module->module);
                    if ($type) {
                        //We know the type name and the old_id. Get its new_id
                        //from backup_ids. It's the instance !!!
                        $instance =  backup_getid($restore->backup_unique_code,$type->name,$cm_module->info);
                        if ($instance) {
                            //We have the new instance, so update the record in course_modules
                            $module->instance = $instance->new_id;
                            //print_object ($module);                             //Debug
                            $status = update_record("course_modules",$module);
                            
                            $changefile = $SESSION->changefiles;
                            if ($type->name == "resource" && !empty($changefile)) {
                                $rsc = get_record("resource","id", $instance->new_id);
                                
                                foreach ($changefile as $oldfile => $newfile) {
                                    $rsc->summary = str_replace("/file.php/".$rsc->course."/".$oldfile."/","/file.php/".$rsc->course."/".$newfile."/",$rsc->summary);
                                    $rsc->alltext = str_replace("/file.php/".$rsc->course."/".$oldfile."/","/file.php/".$rsc->course."/".$newfile."/",$rsc->alltext);
                                    
                                    if($rsc->type == "directory") {
                                        if ($rsc->reference == $oldfile) {
                                            $rsc->reference = $newfile;
                                        }
                                    }
                                    if ($rsc->type == "file" || $rsc->type =="directory") {
                                        $rsc->reference = str_replace($oldfile."/",$newfile."/",$rsc->reference);
                                    }
                                    
                                }
                                $status = update_record("resource", $rsc);
                                
                            } elseif ($type->name == "label"  && !empty($changefile)) {
                                
                                $lbl = get_record("label","id",$instance->new_id);
                                
                                foreach ($changefile as $oldfile=>$newfile) {
                                    $lbl->content = str_replace("/file.php/".$lbl->course."/".$oldfile."/","/file.php/".$lbl->course."/".$newfile."/",$lbl->content);
                                
                                }
                                $status = update_record("label",$lbl);
                                
                            }
                            
                            // For tree resource
                            if ($type->name == "resource" && !empty($changefile)) {
                                if ($rsc->type == 'tree') {
                                    $new_rs_id_ary = $SESSION->new_rs_id_ary;
                                    foreach ($new_rs_id_ary as $rsid => $links) {
                                        $rsc_tree = get_record('resource', 'id', $rsid);
                                        $changefile_isdir = $SESSION->changefile_isdir;
                                        if (!empty($changefile_isdir)) {
                                            $changefile_dir = array();
                                            foreach ($changefile_isdir as $chk_dir) {
                                                foreach ($changefile as $key => $val) {
                                                    if ($key == $chk_dir) {
                                                        $changefile_dir[$key] = $val;
                                                    }
                                                }
                                            }
                                        }
                                        foreach ($changefile_dir as $olddir => $newdir) {
                                                $rsc_tree->alltext = str_replace('/file.php/'. $rsc_tree->course . '/' .$olddir . '/', '/file.php/'. $rsc_tree->course . '/' . $newdir . '/', $rsc_tree->alltext);
                                        }
                                        $changefile_isfil = $SESSION->changefile_isfil;
                                        if (!empty($changefile_isfil)) {
                                            $changefile_file = array();
                                            foreach ($changefile_isfil as $chk_file) {
                                                foreach ($changefile as $key => $val) {
                                                    if ($key == $chk_file) {
                                                        $changefile_file[$key] = $val;
                                                    }
                                                }
                                            }
                                            foreach ($changefile_file as $oldfile => $newfile) {
                                                $rsc_tree->alltext = str_replace('/file.php/'. $rsc_tree->course . '/' .$oldfile, '/file.php/'. $rsc_tree->course . '/' . $newfile, $rsc_tree->alltext);
                                            }
                                        }
                                        $status = update_record("resource", $rsc_tree);
                                    }
                                }
                                
                            }

                        } else {
                            $status = false;
                        }
                        
                    } else {
                        $status = false;
                    }
                    
                } else {
                    $status = false;
                }
            }
        }
        return $status;
    }
    
    /**
     * @param string $errorstr passed by reference, if silent is true,
     * errorstr will be populated and this function will return false rather than calling error() or notify()
     * @param boolean $noredirect (optional) if this is passed, this function will not print continue, or 
     * redirect to the next step in the restore process, instead will return $backup_unique_code
     */
    function restore_precheck_2($id,$file,&$errorstr,$noredirect=false) {
        
        global $CFG, $SESSION;
        
        //Prepend dataroot to variable to have the absolute path
        $file = $CFG->dataroot."/".$file;
        
        if (!defined('RESTORE_SILENTLY')) {
            //Start the main table
            echo "<table cellpadding=\"5\">";
            echo "<tr><td>";
            
            //Start the mail ul
            echo "<ul>";
        }
        
        //Check the file exists 
        if (!is_file($file)) {
            if (!defined('RESTORE_SILENTLY')) {
                error ("File not exists ($file)");
            } else {
                $errorstr = "File not exists ($file)";
                return false;
            }
        }
        
        //Check the file name ends with .zip
        if (!substr($file,-4) == ".zip") {
            if (!defined('RESTORE_SILENTLY')) {
                error ("File has an incorrect extension");
            } else {
                $errorstr = 'File has an incorrect extension';
                return false;
            }
        }
        
        //Now calculate the unique_code for this restore
        $backup_unique_code = time();
        
        //Now check and create the backup dir (if it doesn't exist)
        if (!defined('RESTORE_SILENTLY')) {
            echo "<li>".get_string("creatingtemporarystructures").'</li>';
        }
        $status = check_and_create_backup_dir($backup_unique_code);
        //Empty dir
        if ($status) {
            $status = clear_backup_dir($backup_unique_code);
        }
        
        //Now delete old data and directories under dataroot/temp/backup
        if ($status) {   
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("deletingolddata").'</li>';
            }
            $status = backup_delete_old_data();
        }
        
        //Now copy he zip file to dataroot/temp/backup/backup_unique_code
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("copyingzipfile").'</li>';
            }
            if (! $status = backup_copy_file($file,$CFG->dataroot."/temp/backup/".$backup_unique_code."/".basename($file))) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Error copying backup file. Invalid name or bad perms.");
                } else {
                    $errorstr = "Error copying backup file. Invalid name or bad perms";
                    return false;
                }
            }
        }
        
        //Now unzip the file
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("unzippingbackup").'</li>';
            }
            if (! $status = restore_unzip ($CFG->dataroot."/temp/backup/".$backup_unique_code."/".basename($file))) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Error unzipping backup file. Invalid zip file.");
                } else {
                    $errorstr = "Error unzipping backup file. Invalid zip file.";
                    return false;
                }
            }
        }
        
        //Check for Blackboard backups and convert
        if ($status){
            require_once("$CFG->dirroot/backup/bb/restore_bb.php");
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("checkingforbbexport");
            }
            $status = blackboard_convert($CFG->dataroot."/temp/backup/".$backup_unique_code);
        }
        
        //Now check for the moodle.xml file
        if ($status) {
            $xml_file  = $CFG->dataroot."/temp/backup/".$backup_unique_code."/moodle.xml";
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("checkingbackup").'</li>';
            }
            if (! $status = restore_check_moodle_file ($xml_file)) {
                if (!is_file($xml_file)) {
                    $errorstr = 'Error checking backup file. moodle.xml not found at root level of zip file.';
                } else {
                    $errorstr = 'Error checking backup file. moodle.xml is incorrect or corrupted.';
                }
                if (!defined('RESTORE_SILENTLY')) {
                    notify($errorstr);
                } else {
                    return false;
                }
            }
        }
        
        $info = "";
        $course_header = "";
        
        //Now read the info tag (all)
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("readinginfofrombackup").'</li>';
            }
            //Reading info from file
            $info = restore_read_xml_info ($xml_file);
            //Reading course_header from file
            $course_header = restore_read_xml_course_header ($xml_file);
        }
        
        if (!defined('RESTORE_SILENTLY')) {
            //End the main ul
            echo "</ul>";
            
            //End the main table
            echo "</td></tr>";
            echo "</table>";
        }
        
        //We compare Moodle's versions
        if ($CFG->version < $info->backup_moodle_version && $status) {
            $message->serverversion = $CFG->version;
            $message->serverrelease = $CFG->release;
            $message->backupversion = $info->backup_moodle_version;
            $message->backuprelease = $info->backup_moodle_release;
            print_simple_box(get_string('noticenewerbackup','',$message), "center", "70%", '', "20", "noticebox");
            
        }
        
        //Now we print in other table, the backup and the course it contains info
        if ($info and $course_header and $status) {
            //First, the course info
            if (!defined('RESTORE_SILENTLY')) {
                $status = restore_print_course_header($course_header);
            }
            //Now, the backup info
            if ($status) {
                if (!defined('RESTORE_SILENTLY')) {
                    $status = restore_print_info($info);
                }
            }
        }
        
        //Save course header and info into php session
        if ($status) {
            $SESSION->info = $info;
            $SESSION->course_header = $course_header;
        }
        
        //Finally, a little form to continue
        //with some hidden fields
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<br /><center>";
                $hidden["backup_unique_code"] = $backup_unique_code;
                $hidden["launch"]             = "form";
                $hidden["file"]               =  $file;
                $hidden["id"]                 =  $id;
                print_single_button("restore.php", $hidden, get_string("continue"),"post");
                echo "</center>";
            }
            else {
                if (empty($noredirect)) {
                    redirect_2($CFG->wwwroot.'/mod/resource/type/copy/restore.php?backup_unique_code='.$backup_unique_code.'&launch=form&file='.$file.'&id='.$id,'',0);
                } else {
                    return $backup_unique_code;
                }
            }
        }
        
        if (!$status) {
            if (!defined('RESTORE_SILENTLY')) {
                error ("An error has ocurred");
            } else {
                $errorstr = "An error has occured"; // helpful! :P
                return false;
            }
        }
        return true;
    }

    function restore_execute_2(&$restore,$info,$course_header,&$errorstr) {
        
        global $CFG, $USER;
        $status = true;
        
        //Checks for the required files/functions to restore every module
        //and include the
        
        if ($allmods = get_records("modules") ) {
            foreach ($allmods as $mod) {
                $modname = $mod->name;
                $modfile = "$CFG->dirroot/mod/$modname/restorelib.php";
                //If file exists and we have selected to restore that type of module
                if ((isset($modfile)) and (file_exists($modfile)) and (@$restore->mods[$modname]->restore)) {
                    include_once($modfile);
                }
            }
        }
        
        if (!defined('RESTORE_SILENTLY')) {
            //Start the main table
            echo "<table cellpadding=\"5\">";
            echo "<tr><td>";
            
            //Start the main ul
            echo "<ul>";
        }
        
        //Localtion of the xml file
        $xml_file = $CFG->dataroot."/temp/backup/".$restore->backup_unique_code."/moodle.xml";
        
        //If we've selected to restore into new course
        //create it (course)
        //Saving conversion id variables into backup_tables
        if ($restore->restoreto == 2) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("creatingnewcourse");
            }
            $oldidnumber = $course_header->course_idnumber;
            if (!$status = restore_create_new_course($restore,$course_header)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Error while creating the new empty course.");
                } else {
                    $errorstr = "Error while creating the new empty course.";
                    return false;
                }
            }
            
            //Print course fullname and shortname and category
            if ($status) {
                if (!defined('RESTORE_SILENTLY')) {
                    echo "<ul>";
                    echo "<li>".$course_header->course_fullname." (".$course_header->course_shortname.")".'</li>';
                    echo "<li>".get_string("category").": ".$course_header->category->name.'</li>';
                    if (!empty($oldidnumber)) {
                        echo "<li>".get_string("nomoreidnumber","moodle",$oldidnumber)."</li>";
                    }
                    echo "</ul></li>";
                    //Put the destination course_id
                }
                $restore->course_id = $course_header->course_id;
            }
            
            if ($status = restore_open_html($restore,$course_header)){
                echo "<li>Creating the Restorelog.html in the course backup folder</li>";
            }
            
        } else {
            $course = get_record("course","id",$restore->course_id);
            if ($course) {
                if (!defined('RESTORE_SILENTLY')) {
                    echo "<li>".get_string("usingexistingcourse"); 
                    echo "<ul>";
                    echo "<li>".get_string("from").": ".$course_header->course_fullname." (".$course_header->course_shortname.")".'</li>';
                    echo "<li>".get_string("to").": ".$course->fullname." (".$course->shortname.")".'</li>';
                    if ((@$restore->deleting)) {
                        echo "<li>".get_string("deletingexistingcoursedata").'</li>';
                    } else {
                        echo "<li>".get_string("addingdatatoexisting").'</li>';
                    }
                    echo "</ul></li>";
                }
                //If we have selected to restore deleting, we do it now.
                if (@$restore->deleting) {
                    if (!defined('RESTORE_SILENTLY')) {
                        echo "<li>".get_string("deletingolddata").'</li>';
                    }
                    $status = remove_course_contents($restore->course_id,false) and 
                        delete_dir_contents($CFG->dataroot."/".$restore->course_id,"backupdata");
                    if ($status) {
                        //Now , this situation is equivalent to the "restore to new course" one (we
                        //have a course record and nothing more), so define it as "to new course"
                        $restore->restoreto = 2;
                    } else {
                        if (!defined('RESTORE_SILENTLY')) {
                            notify("An error occurred while deleting some of the course contents.");
                        } else {
                            $errrostr = "An error occurred while deleting some of the course contents.";
                            return false;
                        }
                    }
                }
            } else {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Error opening existing course.");
                    $status = false;
                } else {
                    $errorstr = "Error opening existing course.";
                    return false;
                }
            }
        }
        
        //Now create the course_sections and their associated course_modules
        if ($status) {
            //Into new course
            if ($restore->restoreto == 2) {
                if (!defined('RESTORE_SILENTLY')) {
                    echo "<li>".get_string("creatingsections").'</li>';
                }
                if (!$status = restore_create_sections_2($restore,$xml_file)) {
                    if (!defined('RESTORE_SILENTLY')) {
                        notify("Error creating sections in the existing course.");
                    } else {
                        $errorstr = "Error creating sections in the existing course.";
                        return false;
                    }
                }
                //Into existing course
            } else if ($restore->restoreto == 0 or $restore->restoreto == 1) {
                if (!defined('RESTORE_SILENTLY')) {
                    echo "<li>".get_string("checkingsections").'</li>';
                }
                if (!$status = restore_create_sections_2($restore,$xml_file)) {
                    if (!defined('RESTORE_SILENTLY')) {
                        notify("Error creating sections in the existing course.");
                    } else {
                        $errorstr = "Error creating sections in the existing course.";
                        return false;
                    } 
                }
                //Error
            } else {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Neither a new course or an existing one was specified.");
                    $status = false;
                } else {
                    $errorstr = "Neither a new course or an existing one was specified.";
                    return false;
                }
            }
        }
        
        //Now create users as needed 
        if ($status and ($restore->users == 0 or $restore->users == 1)) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("creatingusers")."<br />";
            }
            if (!$status = restore_create_users($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore users.");
                } else {
                    $errorstr = "Could not restore users.";
                    return false;
                }
            }
            
            //Now print info about the work done
            if ($status) {
                $recs = get_records_sql("select old_id, new_id from {$CFG->prefix}backup_ids
                                     where backup_code = '$restore->backup_unique_code' and
                                     table_name = 'user'");
                //We've records
                if ($recs) {
                    $new_count = 0;
                    $exists_count = 0;
                    $student_count = 0;
                    $teacher_count = 0;
                    $counter = 0;
                    //Iterate, filling counters
                    foreach ($recs as $rec) {
                        //Get full record, using backup_getids
                        $record = backup_getid($restore->backup_unique_code,"user",$rec->old_id);
                        if (strpos($record->info,"new") !== false) {
                            $new_count++;
                        } 
                        if (strpos($record->info,"exists") !== false) {
                            $exists_count++;
                        }
                        if (strpos($record->info,"student") !== false) {
                            $student_count++;
                        } else if (strpos($record->info,"teacher") !== false) {
                            $teacher_count++;
                        }
                        //Do some output
                        $counter++;
                        if ($counter % 10 == 0) {
                            if (!defined('RESTORE_SILENTLY')) {
                                echo ".";
                                if ($counter % 200 == 0) {
                                    echo "<br />";
                                }
                            }
                            backup_flush(300);
                        }
                    }
                    if (!defined('RESTORE_SILENTLY')) {
                        //Now print information gathered
                        echo " (".get_string("new").": ".$new_count.", ".get_string("existing").": ".$exists_count.")";
                        echo "<ul>";
                        echo "<li>".get_string("students").": ".$student_count.'</li>';
                        echo "<li>".get_string("teachers").": ".$teacher_count.'</li>';
                        echo "</ul>";
                    }
                } else {
                    if (!defined('RESTORE_SILENTLY')) {
                        notify("No users were found!");
                    } // no need to return false here, it's recoverable.
                }
            }
        }
       
        //Now create metacourse info
        if ($status and @$restore->metacourse) {
            //Only to new courses!
            if ($restore->restoreto == 2) {
                if (!defined('RESTORE_SILENTLY')) {
                    echo "</li><li>".get_string("creatingmetacoursedata");
                }
                if (!$status = restore_create_metacourse($restore,$xml_file)) {
                    if (!defined('RESTORE_SILENTLY')) {
                        notify("Error creating metacourse in the course.");
                    } else {
                        $errorstr = "Error creating metacourse in the course.";
                        return false;
                    }
                }
            }
        }
        
        //Now create categories and questions as needed
        if ($status and (@$restore->mods['quiz']->restore)) {
            include_once("$CFG->dirroot/question/restorelib.php");
            if (!defined('RESTORE_SILENTLY')) {
                echo "</li><li>".get_string("creatingcategoriesandquestions");
                echo "<ul>";
            }
            if (!$status = restore_create_questions($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore categories and questions!");
                } else {
                    $errorstr = "Could not restore categories and questions!";
                    return false;
                }
            }
            if (!defined('RESTORE_SILENTLY')) {
                echo "</ul></li>";
            }
        }
        
        //Now create user_files as needed
        if ($status and (@$restore->user_files)) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("copyinguserfiles");
            }
            if (!$status = restore_user_files($restore)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore user files!");
                } else {
                    $errorstr = "Could not restore user files!";
                    return false;
                }
            }
            //If all is ok (and we have a counter)
            if ($status and ($status !== true)) {
                //Inform about user dirs created from backup
                if (!defined('RESTORE_SILENTLY')) {
                    echo "<ul>";
                    echo "<li>".get_string("userzones").": ".$status;
                    echo "</li></ul>";
                }
            }
        }
        
        //Now create course files as needed
        if ($status and ($restore->course_files)) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "</li><li>".get_string("copyingcoursefiles")."</li>";
            }
            if (!$status = restore_course_files($restore)) {
                if (empty($status)) {
                    notify("Could not restore course files!");
                } else {
                    $errorstr = "Could not restore course files!";
                    return false;
                }
            }
            //If all is ok (and we have a counter)
            if ($status and ($status !== true)) {
                //Inform about user dirs created from backup
                if (!defined('RESTORE_SILENTLY')) {
                    echo "<ul>";
                    echo "<li>".get_string("filesfolders").": ".$status;
                    echo "</ul>";
                }       
            }
        }
        
        //Now create messages as needed
        if ($status and (@$restore->messages)) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("creatingmessagesinfo");
            }
            if (!$status = restore_create_messages($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore messages!");
                } else {
                    $errorstr = "Could not restore messages!";
                    return false;
                }
            }
            if (!defined('RESTORE_SILENTLY')) {
                echo "</li>";
            }
        }
        //Now create scales as needed
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("creatingscales").'</li>';
            }
            if (!$status = restore_create_scales($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore custom scales!");
                } else {
                    $errorstr = "Could not restore custom scales!";
                    return false;
                }
            }
        }
        
        //Now create groups as needed
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("creatinggroups").'</li>';
            }
            if (!$status = restore_create_groups($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore groups!");
                } else {
                    $errorstr = "Could not restore groups!";
                    return false;
                }
            }
        }
        
        //Now create events as needed
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("creatingevents").'</li>';
            }
            if (!$status = restore_create_events($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore course events!");
                } else {
                    $errorstr = "Could not restore course events!";
                    return false;
                }
            }
        }
        
        //Now create course modules as needed
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("creatingcoursemodules");
            } 
            if (!$status = restore_create_modules($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore modules!");
                } else {
                    $errorstr = "Could not restore modules!";
                    return false;
                }
            }
        }
        
        //Now create gradebook as needed -- AFTER modules!!!
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("creatinggradebook");
            } 
            if (!$status = restore_create_gradebook($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore gradebook!");
                } else {
                    $errorstr = "Could not restore gradebook!";
                    return false;
                }
            }
        }
        
        //Bring back the course blocks -- do it AFTER the modules!!!
        if($status) {
            //If we are deleting and bringing into a course or making a new course, same situation
            if($restore->restoreto == 0 || $restore->restoreto == 2) {
                if (!defined('RESTORE_SILENTLY')) {
                    echo '<li>'.get_string('creatingblocks').'</li>';
                }
                $course_header->blockinfo = !empty($course_header->blockinfo) ? $course_header->blockinfo : NULL;
                if (!$status = restore_create_blocks($restore, $info->backup_block_format, $course_header->blockinfo, $xml_file)) {
                    if (!defined('RESTORE_SILENTLY')) {
                        notify('Error while creating the course blocks');
                    } else {
                        $errorstr = "Error while creating the course blocks";
                        return false;
                    }
                }
            }
        }
        
        //Now create log entries as needed
        if ($status and (@$restore->logs)) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "</li><li>".get_string("creatinglogentries");
            }
            if (!$status = restore_create_logs($restore,$xml_file)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not restore logs!");
                } else {
                    $errorstr = "Could not restore logs!";
                    return false;
                }
            }
        }
        
        //Now, if all is OK, adjust the instance field in course_modules !!
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "</li><li>".get_string("checkinginstances").'</li>';
            }
            if (!$status = restore_check_instances_2($restore)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not adjust instances in course_modules!");
                } else {
                    $errorstr = "Could not adjust instances in course_modules!";
                    return false;
                }
            }
        }
        
        //Now, if all is OK, adjust activity events
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("refreshingevents").'</li>';
            }
            if (!$status = restore_refresh_events($restore)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not refresh events for activities!");
                } else {
                    $errorstr = "Could not refresh events for activities!";
                    return false;
                }
            }
        }
        
        //Now, if all is OK, adjust inter-activity links
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("decodinginternallinks");
            }
            if (!$status = restore_decode_content_links($restore)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not refresh events for activities!");
                } else {
                    $errorstr = "Could not refresh events for activities!";
                    return false;
                }
            }
        }
        
        //Now, with backup files prior to version 2005041100,
        //convert all the wiki texts in the course to markdown
        if ($status && $restore->backup_version < 2005041100) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("convertingwikitomarkdown");
            }
            if (!$status = restore_convert_wiki2markdown($restore)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not convert wiki texts to markdown!");
                } else {
                    $errorstr = "Could not convert wiki texts to markdown!";
                    return false;
                }
            }
        }
        
        /*******************************************************************************
         ************* Restore of Roles and Capabilities happens here ******************
         *******************************************************************************/
        
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "</li><li>".get_string("checkingcourse").'</li>';
            } 
            //modinfo field
            rebuild_course_cache($restore->course_id);
            //categories table
            $course = get_record("course","id",$restore->course_id); 
            fix_course_sortorder();
            // Check if the user has course update capability in the newly restored course
            // there is no need to load his capabilities again, because restore_roles_settings
            // would have loaded it anyway, if there is any assignments. 
            // fix for MDL-6831
            $newcontext = get_context_instance(CONTEXT_COURSE, $restore->course_id);
            if (!has_capability('moodle/course:manageactivities', $newcontext)) {
                if ($legacyteachers = get_roles_with_capability('moodle/legacy:editingteacher', CAP_ALLOW, get_context_instance(CONTEXT_SYSTEM, SITEID))) {
                    if ($legacyteacher = array_shift($legacyteachers)) {
                        role_assign($legacyteacher->id, $USER->id, 0, $newcontext->id);
                    }
                } else {
                    notify('Could not find a legacy teacher role. You might need your moodle admin to assign a role with editing privilages to this course.');
                }
            }
        }
        
        //Cleanup temps (files and db)
        if ($status) {
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("cleaningtempdata").'</li>';
            }
            if (!$status = clean_temp_data ($restore)) {
                if (!defined('RESTORE_SILENTLY')) {
                    notify("Could not clean up temporary data from files and database");
                } else {
                    $errorstr = "Could not clean up temporary data from files and database";
                    return false;
                }
            }
        }
        
        if ($status = restore_close_html($restore)){
            echo "<li>Closing the Restorelog.html file.<li>";
        }
        
        if (!defined('RESTORE_SILENTLY')) {
            //End the main ul
            echo "</ul>";
            
            //End the main table     
            echo "</td></tr>";
            echo "</table>";
        }
        
        return $status;
    }

    function redirect_2($url, $message='', $delay=-1) {
        
        global $CFG;
        
        if (!empty($CFG->usesid) && !isset($_COOKIE[session_name()])) {
           $url = sid_process_url($url);
        }
        
        $message = clean_text($message);
        
        $url = html_entity_decode($url);
        $url = str_replace(array("\n", "\r"), '', $url); // some more cleaning
        $encodedurl = htmlentities($url);
        $tmpstr = clean_text('<a href="'.$encodedurl.'" />'); //clean encoded URL
        $encodedurl = substr($tmpstr, 9, strlen($tmpstr)-13);
        $url = html_entity_decode($encodedurl);
        $surl = addslashes($url); 
        
    /// when no message and header printed yet, try to redirect
        if (empty($message) and !defined('HEADER_PRINTED')) {
        
            // Technically, HTTP/1.1 requires Location: header to contain
            // the absolute path. (In practice browsers accept relative 
            // paths - but still, might as well do it properly.)
            // This code turns relative into absolute. 
            if (!preg_match('|^[a-z]+:|', $url)) { 
                // Get host name http://www.wherever.com
                $hostpart = preg_replace('|^(.*?[^:/])/.*$|', '$1', $CFG->wwwroot);
                if (preg_match('|^/|', $url)) {
                    // URLs beginning with / are relative to web server root so we just add them in
                    $url = $hostpart.$url;
                } else {
                    // URLs not beginning with / are relative to path of current script, so add that on.
                    $url = $hostpart.preg_replace('|\?.*$|','',me()).'/../'.$url;
                }
                // Replace all ..s
                while (true) {
                    $newurl = preg_replace('|/[^/]*/\.\./|', '/', $url);
                    if ($newurl == $url) {
                        break;
                    }
                    $url = $newurl;
                }
            }
            
            $delay = 0;
            //try header redirection first
            @header($_SERVER['SERVER_PROTOCOL'] . ' 303 See Other'); //302 might not work for POST requests, 303 is ignored by obsolete clients
            @header('Location: '.$url);
            //another way for older browsers and already sent headers (eg trailing whitespace in config.php)
            echo '<meta http-equiv="refresh" content="'. $delay .'; url='. $encodedurl .'" />';
            echo '<script type="text/javascript">'. "\n" .'<!--'. "\n". "location.replace('$surl');". "\n". '//-->'. "\n". '</script>';   // To cope with Mozilla bug
            die;
        }
        
        if ($delay == -1) {
            $delay = 3;  // if no delay specified wait 3 seconds
        }
        if (! defined('HEADER_PRINTED')) {
            // this type of redirect might not be working in some browsers - such as lynx :-(
            print_header('', '', '', '', '<meta http-equiv="refresh" content="'. $delay .'; url='. $encodedurl .'" />');
            $delay += 3; // double redirect prevention, it was sometimes breaking upgrades before 1.7
        }
        echo '<center>';
        echo '<p>'. get_string('copyloading','resource') .'</p>';
        echo '</center>';
    // it might be better not to set timeout the same for both types of redirect, so that we can be sure which one wins 
?>
<script type="text/javascript">
<!--

  function redirect() {
      document.location.replace('<?php echo $surl ?>');
  }
  setTimeout("redirect()", <?php echo ($delay * 1000) ?>);
-->
</script>
<?php
    die;
}
    
?>